package com.hzya.frame.plugin.ncc.service.impl;

import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.plugin.ncc.service.IPOrderBService;
import com.hzya.frame.plugin.ncc.service.IPOrderHService;
import com.hzya.frame.plugin.ncc.service.IPoOrderPluginInService;
import com.hzya.frame.seeyon.util.OARestUtil;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;

import java.util.LinkedList;
import java.util.List;

/**
 * @Description NCC采购订单
 * @Author xiangerlin
 * @Date 2025/6/3 19:09
 **/
public class PoOrderPluginInServiceImpl implements IPoOrderPluginInService {

    Logger logger = LoggerFactory.getLogger(PoOrderPluginInServiceImpl.class);
    @Autowired
    private IPOrderHService pOrderHService;
    @Autowired
    private IPOrderBService pOrderBService;
    @Value("${zt.url}")
    private String interfaceUrl;
    @Autowired
    private OARestUtil oaRestUtil;
    /**
     * NCC采购订单传到OA走审批流
     *
     * @param requestJson
     * @return
     */
    @Override
    public JsonResultEntity sync2oa(JSONObject requestJson) {
        //数据源编码
        String datasourceCode = requestJson.getString("sourceCode");
        if (StrUtil.isNotEmpty(datasourceCode)){
            //查NCC单据
            //组装参数
            JSONObject formmain_0256 = new JSONObject();//主表数据
            List<JSONObject> formson_0257_list = new LinkedList<>();//子表数据
            formmain_0256.put("采购组织","");
            formmain_0256.put("订单编号","");
            formmain_0256.put("订单日期","");
            formmain_0256.put("供应商","");
            formmain_0256.put("采购员","");
            formmain_0256.put("开票供应商","");
            formmain_0256.put("付款协议","");
            formmain_0256.put("发起人","");
            formmain_0256.put("单据状态","");
            formmain_0256.put("备注","");
            formmain_0256.put("补货","");
            formmain_0256.put("退货","");
            formmain_0256.put("总数量","");
            formmain_0256.put("总价税合计","");
            formmain_0256.put("币种","");
            formmain_0256.put("退货退库基于原订单补货","");
            formmain_0256.put("最终关闭","");
            formmain_0256.put("采购部门","");
            formmain_0256.put("订单类型","");
            //子表
            JSONObject formson_0257 = new JSONObject();
            formson_0257.put("收货库存组织","");
            formson_0257.put("行号","");
            formson_0257.put("物料编码","");
            formson_0257.put("物料名称","");
            formson_0257.put("单位","");
            formson_0257.put("数量","");
            formson_0257.put("换算率","");
            formson_0257.put("无税单价","");
            formson_0257.put("含税单价","");
            formson_0257.put("集团本币无税金额","");
            formson_0257.put("集团本币价税合计","");
            formson_0257.put("计划收货日期","");
            formson_0257.put("收货仓库","");
            formson_0257.put("税率","");
            formson_0257_list.add(formson_0257);
            String param = oaRestUtil.processParamValueOf(formmain_0256, formson_0257_list, "模板编号", "formmain_0256", "formson_0257");
            String token = oaRestUtil.getToken("hzyaRest", "8000640001");
            logger.info("NCC发起OA采购订单请求参数{}",param);
            //调用OA接口
            String result = HttpRequest.post(interfaceUrl)
                    .header("token",token)// token
                    .header("appId","800064")// 建辉OA应用
                    .header("apiCode","8000640000")//流程表单接口
                    .header("publicKey","ZJYAAr9TeFduBYu7uJeie2KYdQsnBaEYZHmOjPWMMVZmzelCe7eDIk+3zDUT+v578prj")//NCC应用key
                    .header("secretKey","f4SSnYcDQmdkwwuGJd2+934q6lM1NnUm5dmOw/4Wvy2mo6PgkKsI/drXYyyLWQCaj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")//NCC应用密钥
                    .body(param).execute().body();
            // JsonResultEntity resultEntity = (JsonResultEntity) oerDjmlService.handleOerDjml(paramJSON);
            // logger.info("保存GRPU8响应参数:{}",JSONObject.toJSON(resultEntity));
            logger.info("NCC发起OA采购订单响应参数:{}",result);
            //更新NCC推送状态
        }
        return null;
    }
}
